import org.jdesktop.swingx.mapviewer.DefaultTileFactory;
import org.jdesktop.swingx.mapviewer.TileFactory;
import org.jdesktop.swingx.mapviewer.TileFactoryInfo;



/**
 * 	Esta clase se encarga de crear el encabezado http para que el servidor de google nos retorne el mapa.
 * De esta manera hacemos creer al servidor que somos una pagina web. 
 * 
 * Superclase de Tipo Mapa.
 * 
 * @author Gunther Bevense,Claudio Castro, Marcelo Rutte.
 * 
 */


public class GoogleMapsTileProvider 

	
	{
	
	  private static final String VERSION = "2.75";
	  private static final int minZoom = 1;
	  private static final int maxZoom = 8;
	  private static final int mapZoom = 17;
	  private static final int tileSize = 256;
	  private static final boolean xr2l = true;
	  private static final boolean yt2b = true;
	  private static final String baseURL ="http://mt1.google.com/mt?n=404&v=w" + VERSION;
	  private static final String x = "x";
	  private static final String y = "y";
	  private static final String z = "zoom";
	  private static TileFactoryInfo  GOOGLE_MAPS_TILE_INFO = new TileFactoryInfo(minZoom, maxZoom, mapZoom, tileSize, xr2l,yt2b, baseURL, x, y, z);
	
	 
	  
	  /** Clase que entrega el encabesado.
	   * 
	   * @return TileFactory.
	   */
	  public static TileFactory getDefaultTileFactory()
	
	    {
	     return (new DefaultTileFactory(GOOGLE_MAPS_TILE_INFO));
	    }
      
	  
	}
