import java.util.*;


public class Sorter {

    /**
     * mtodo que ordena un arreglo desde el ndice 0 hasta el tamao del arreglo menos 1
     */

  public void sort() {
    quicksort(0, size()-1);
  }

  /**
   * mtodo quicksort para ordenar el arreglo
   * @param i ndice que se mueve en el arreglo para poder compararla con otro.
   * @param j ndice que se mueve en el arreglo para poder compararla con otro.
   */

  void quicksort(int i, int j) {
    if (i>=j)
      return;
    int k= partition(i, j);
    quicksort(i, k-1);
    quicksort(k+1, j);
  }
  /**
   * mtodo que es llamado desde el quicksort y que permite realizar particiones del arreglo
   * @param i ndice que se mueve en el arreglo para ir formando particiones
   * @param j ndice que se mueve en el arreglo para ir formando particiones
   * @return retorna el valor del ndice encontrado en la particin
   */

  int partition(int i, int j) {
    int k= i;
    i++;
    for(;;) {
      while (i<j && compare(i,k)<=0)
        i++;
      while (i<j && compare(j,k)>=0)
        j--;
      if (i==j)
        break;
      swap(i,j);
    }
    if (compare(k,i)<0)
      i--;
    swap(k,i);
    return i;
  }

  // Las componentes modulares del algoritmo

  // La declaracion del arreglo
  public double[] array;
  public String[] strings;
  /**
   * Constructor.
   * Crea un objeto compuesto de 2 arreglos 
   * @param array arreglo de enteros que va a ser ordenado
   * @param strings arreglo de strings que va a ser ordenado
   */

  public Sorter(double[] array,String[] strings) {
    this.array= array;
    this.strings=strings;
  
  }

  // Defina aquí el método swap
  // argumentos: dos índices de elementos en el arreglo array
  // acción: los intercambia
  // resultado: nada
  
  /**
   * mtodo que intercambia una componente por otra de los arreglo
   * @param i ndice que indica una de las componentes a ser intercambiada
   * @param j ndice que indica la otra de las componentes a ser intercambiada
   */

  public void swap(int i, int j) {
    double x= array[i];
    String xx=strings[i];
    array[i]= array[j];
    strings[i]=strings[j];
    array[j]= x;
    strings[j]=xx; 
  }

  /**
   * Compara dos componentes de un arreglo
   * @param i ndice que indica una de las componentes a ser comparada
   * @param j ndice que indica una de las componentes a ser comparada
   * @return retorna 0 si las componentes son iguales, -1 si la primera de las componentes es menor y 1 si la primera de las componentes es mayor
   */
  public int compare(int i, int j) {
    if (array[i]<array[j]) return -1;
    else if (array[i]==array[j]) return 0;
    else return 1;
  }

  /**
   * permite obtener el tamao del 
   * @return retorna el tamao del arreglo
   */
  public int size() { return array.length; }
 
  /**
   * permite imprimir los arreglos en pantalla
   */
  public void print() {
    for(int i=0; i<size(); i++)
    {System.out.print(array[i]+" ");
    System.out.print(strings[i] +" ");
    System.out.println();}
  }
}